%define majver %(echo %version | cut -d. -f1-2)
Name:          qt6-qtwebengine
Version:       6.4.3
Release:       1mamba
Summary:       Qt6 WebEngine component
Group:         System/Libraries
Vendor:        openmamba
Distribution:  openmamba
Packager:      Silvan Calarco <silvan.calarco@mambasoft.it>
URL:           https://www.qt.io/
Source:        https://download.qt.io/official_releases/qt/%{majver}/%{version}/submodules/qtwebengine-everywhere-src-%{version}.tar.xz
Patch0:        qt6-qtwebengine-6.2.3-ffmpeg-5.0.patch
Patch1:        qt6-qtwebengine-6.3.0-icu-71.1.patch
License:       GPL
## AUTOBUILDREQ-BEGIN
BuildRequires: glibc-devel
BuildRequires: libX11-devel
BuildRequires: libXcomposite-devel
BuildRequires: libXdamage-devel
BuildRequires: libXext-devel
BuildRequires: libXfixes-devel
BuildRequires: libXi-devel
BuildRequires: libXrandr-devel
BuildRequires: libXrender-devel
BuildRequires: libXtst-devel
BuildRequires: libalsa-devel
BuildRequires: libavcodec-ffmpeg-devel
BuildRequires: libavformat-ffmpeg-devel
BuildRequires: libavutil-ffmpeg-devel
BuildRequires: libdbus-devel
BuildRequires: libevent-devel
BuildRequires: libexpat-devel
BuildRequires: libfontconfig-devel
BuildRequires: libfreetype-devel
BuildRequires: libgcc
BuildRequires: libglib-devel
BuildRequires: libglvnd-devel
BuildRequires: libharfbuzz-devel
BuildRequires: libicu-devel
BuildRequires: libjpeg-devel
BuildRequires: liblcms2-devel
BuildRequires: libmesa-devel
BuildRequires: libminizip1-devel
BuildRequires: libnspr-devel
BuildRequires: libnss-devel
BuildRequires: libopus-devel
BuildRequires: libpci-devel
BuildRequires: libpng-devel
BuildRequires: libre2-devel
BuildRequires: libsnappy-devel
BuildRequires: libstdc++6-devel
BuildRequires: libvpx-devel
BuildRequires: libwebp-devel
BuildRequires: libxcb-devel
BuildRequires: libxkbcommon-devel
BuildRequires: libxkbfile-devel
BuildRequires: libxshmfence-devel
BuildRequires: libz-devel
BuildRequires: qt6-qtbase-devel
BuildRequires: qt6-qtdeclarative-devel
BuildRequires: qt6-qtpositioning-devel
BuildRequires: qt6-qttools-devel
BuildRequires: qt6-qtwebchannel-devel
## AUTOBUILDREQ-END
BuildRequires: qt6-qtdeclarative-devel = %{version}
BuildRequires: python-html5lib-py3

%description
Qt6 WebEngine component.

%package devel
Group:         Development/Libraries
Summary:       Development files for %{name}
Requires:      %{name} = %{?epoch:%epoch:}%{version}-%{release}

%description devel
This package contains libraries and header files for developing applications that use %{name}.

%debug_package

# Don't clean build at the end
%global __spec_rmbuild_cmd /bin/true

%prep
%setup -q -n qtwebengine-everywhere-src-%{version}
#-D -T
#:<< _EOF
cd src/3rdparty
#%patch0 -p1 -b .ffmpeg-5.0
#%patch1 -p1 -b .icu-71.1
cd ../..

%build
#:<< _EOF
# Prevent build server slowness/crash due to memory
%ifarch arm
export NINJAFLAGS="-j1"
%else
export NINJAFLAGS="-j2"
%endif

%ifarch %{ix86} aarch64
export CXXFLAGS+="%{optflags} -Os -s -ffunction-sections -fdata-sections -Wl,--gc-sections -Wl,--no-keep-memory -fPIC -fno-delete-null-pointer-checks -fno-lifetime-dse -fno-schedule-insns2 -Wl,--no-fatal-warnings"
%else
export CXXFLAGS+="%{optflags} -fPIC -fno-delete-null-pointer-checks -fno-lifetime-dse -fno-schedule-insns2 -Wl,--no-fatal-warnings"
%endif

%cmake -d build \
  -G Ninja \
  -DQT_FEATURE_webengine_system_ffmpeg=ON \
  -DQT_FEATURE_webengine_system_icu=ON \
  -DQT_FEATURE_webengine_system_libevent=ON \
  -DQT_FEATURE_webengine_proprietary_codecs=ON \
  -DQT_FEATURE_webengine_kerberos=ON \
  -DQT_FEATURE_webengine_webrtc_pipewire=ON \
  -DQT_FEATURE_webengine_full_debug_info=ON

cmake --build .

%install
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"

DESTDIR="%{buildroot}" cmake --install build

%clean
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
#-f %{name}.lang
%defattr(-,root,root)
%{_libdir}/libQt6WebEngineCore.so.*
%{_libdir}/libQt6WebEngineWidgets.so.*
%{_libdir}/libQt6WebEngineQuick.so.*
%{_libdir}/libQt6WebEngineQuickDelegatesQml.so.*
%{_libdir}/libQt6Pdf.so.*
%{_libdir}/libQt6PdfQuick.so.*
%{_libdir}/libQt6PdfWidgets.so.*
%{_libdir}/qt6/libexec/*
%{_libdir}/qt6/plugins/imageformats/libqpdf.so
%{_libdir}/qt6/plugins/designer/libqwebengineview.so
%{_datadir}/qt6/resources/qtwebengine_devtools_resources.pak
%{_datadir}/qt6/resources/qtwebengine_resources.pak
%{_datadir}/qt6/resources/qtwebengine_resources_100p.pak
%{_datadir}/qt6/resources/qtwebengine_resources_200p.pak
%dir %{_datadir}/qt6/translations/qtwebengine_locales
%dir %{_libdir}/qml/QtWebEngine
%{_libdir}/qml/QtWebEngine/*
%dir %{_libdir}/qml/QtQuick/Pdf
%{_libdir}/qml/QtQuick/Pdf/*
%{_libdir}/metatypes/qt6*.json
%{_datadir}/qt6/translations/qtwebengine_locales/*.pak
%{_datadir}/qt6/modules/WebEngine*.json
%{_datadir}/qt6/modules/Pdf*.json
%doc LICENSES LICENSE.Chromium

%files devel
%defattr(-,root,root)
%dir %{_includedir}/qt6/Qt*
%{_includedir}/qt6/Qt*/*
%{_libdir}/libQt6WebEngineCore.prl
%{_libdir}/libQt6WebEngineCore.so
%{_libdir}/libQt6WebEngineWidgets.prl
%{_libdir}/libQt6WebEngineWidgets.so
%{_libdir}/libQt6WebEngineQuick.prl
%{_libdir}/libQt6WebEngineQuick.so
%{_libdir}/libQt6WebEngineQuickDelegatesQml.prl
%{_libdir}/libQt6WebEngineQuickDelegatesQml.so
%{_libdir}/libQt6Pdf*.prl
%{_libdir}/libQt6Pdf*.so
%{_libdir}/qt6/mkspecs/modules/qt_lib_*.pri
%{_libdir}/cmake/Qt6BuildInternals/StandaloneTests/QtWebEngineTestsConfig.cmake
%{_libdir}/cmake/Qt6Qml/QmlPlugins/Qt6*.cmake
%dir %{_libdir}/cmake/Qt6*
%{_libdir}/cmake/Qt6*/*.cmake
%{_libdir}/pkgconfig/Qt6*.pc

%changelog
* Sun Mar 19 2023 Automatic Build System <autodist@mambasoft.it> 6.4.3-1mamba
- automatic version update by autodist

* Sun Jan 08 2023 Automatic Build System <autodist@mambasoft.it> 6.4.2-1mamba
- automatic version update by autodist

* Tue Nov 22 2022 Automatic Build System <autodist@mambasoft.it> 6.4.1-1mamba
- automatic version update by autodist

* Fri Oct 07 2022 Silvan Calarco <silvan.calarco@mambasoft.it> 6.4.0-1mamba
- update to 6.4.0

* Tue Sep 13 2022 Automatic Build System <autodist@mambasoft.it> 6.3.2-1mamba
- automatic version update by autodist

* Sun Jun 19 2022 Automatic Build System <autodist@mambasoft.it> 6.3.1-1mamba
- automatic version update by autodist

* Thu Apr 14 2022 Silvan Calarco <silvan.calarco@mambasoft.it> 6.3.0-1mamba
- update to 6.3.0

* Mon Mar 21 2022 Automatic Build System <autodist@mambasoft.it> 6.2.4-1mamba
- automatic version update by autodist

* Sun Feb 20 2022 Silvan Calarco <silvan.calarco@mambasoft.it> 6.2.3-1mamba
- update to 6.2.3

* Fri Dec 24 2021 Silvan Calarco <silvan.calarco@mambasoft.it> 5.15.7-1mamba
- update to 5.15.7

* Sat Jan 02 2021 Silvan Calarco <silvan.calarco@mambasoft.it> 5.15.2-1mamba
- update to 5.15.2

* Mon Oct 19 2020 Silvan Calarco <silvan.calarco@mambasoft.it> 5.15.1-1mamba
- update to 5.15.1

* Mon Aug 31 2020 Silvan Calarco <silvan.calarco@mambasoft.it> 5.15.0-2mamba
- rebuilt with system ffmpeg and icu

* Fri Aug 28 2020 Silvan Calarco <silvan.calarco@mambasoft.it> 5.15.0-1mamba
- update to 5.15.0

* Tue Apr 07 2020 Silvan Calarco <silvan.calarco@mambasoft.it> 5.14.2-1mamba
- update to 5.14.2

* Wed Oct 23 2019 Silvan Calarco <silvan.calarco@mambasoft.it> 5.13.1-1mamba
- update to 5.13.1

* Sun Jun 23 2019 Silvan Calarco <silvan.calarco@mambasoft.it> 5.13.0-1mamba
- update to 5.13.0

* Tue May 07 2019 Silvan Calarco <silvan.calarco@mambasoft.it> 5.12.3-1mamba
- update to 5.12.3

* Tue Mar 19 2019 Silvan Calarco <silvan.calarco@mambasoft.it> 5.12.2-1mamba
- update to 5.12.2

* Sun Feb 10 2019 Silvan Calarco <silvan.calarco@mambasoft.it> 5.12.1-1mamba
- update to 5.12.1

* Sun Dec 30 2018 Automatic Build System <autodist@mambasoft.it> 5.12.0-1mamba
- automatic version update by autodist

* Sat Nov 03 2018 Silvan Calarco <silvan.calarco@mambasoft.it> 5.11.2-1mamba
- update to 5.11.2

* Sat Jul 21 2018 Silvan Calarco <silvan.calarco@mambasoft.it> 5.11.1-1mamba
- update to 5.11.1

* Wed Jun 06 2018 Silvan Calarco <silvan.calarco@mambasoft.it> 5.11.0-1mamba
- update to 5.11.0

* Sat Feb 24 2018 Silvan Calarco <silvan.calarco@mambasoft.it> 5.10.1-1mamba
- update to 5.10.1

* Sat Jan 27 2018 Silvan Calarco <silvan.calarco@mambasoft.it> 5.10.0-1mamba
- update to 5.10.0

* Thu Oct 19 2017 Silvan Calarco <silvan.calarco@mambasoft.it> 5.9.2-1mamba
- update to 5.9.2

* Fri Dec 16 2016 Silvan Calarco <silvan.calarco@mambasoft.it> 5.7.1-1mamba
- update to 5.7.1

* Thu Dec 15 2016 Silvan Calarco <silvan.calarco@mambasoft.it> 5.7.0-4mamba
- rebuilt with gcc

* Thu Dec 15 2016 Silvan Calarco <silvan.calarco@mambasoft.it> 5.7.0-3mamba
- rebuilt with -fno-delete-null-pointer-checks CXXFLAGS and use_system_ffmpeg

* Thu Dec 15 2016 Silvan Calarco <silvan.calarco@mambasoft.it> 5.7.0-2mamba
- bump release to allow update with qt6 release update

* Sat Jul 16 2016 Silvan Calarco <silvan.calarco@mambasoft.it> 5.7.0-1mamba
- package created using the webbuild interface
